#include "allegro.h"
#define FAIL(X) { return X; }

/* number of bytes per sample (1 -> 8 bit ; 2 -> 16 bit) */
#define BYTES_PER_SAMPLE 2

void main(int argc, char *argv[])
{
	int bytesWritten, len, i;
  	char *src,*end, *dst;
	SAMPLE *spl = NULL;
	int freq = 1000;
  
	allegro_init();
   	install_timer();
	printf ("Getting ready to init sound \n");
	if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL) != 0) 
		{
      	printf("Error initialising sound system\n%s\n", allegro_error);
      	return;
    		}
	printf ("OK \n");
	len = 100;
	spl = malloc(sizeof(SAMPLE)); 
 	if (spl) 
		{                    /* initialise the sample struct */
	    	spl->bits = 8;
	    	spl->freq = freq;
	    	spl->len = len;

	    	spl->data = malloc(len);
		dst = (char *) spl->data;
	    	if (!dst) 
			{
	      	free(spl);
	      	spl = NULL;
	    		}
	    	else 
			{                     		/* read the actual sample data */
	       	if (BYTES_PER_SAMPLE == 1) 	/* 8 bit */
				{
		  		for (i=0;i<len;i++)
					*dst++ = i;
	       		}
	       	else 					/* 16 bit */
				{
				printf ("Getting ready to write\n");
		  		for (i=0;i<len;i++)
	        			*dst++ = i+1000;
				printf ("Finished write\n");
		  		}
	       	}
/*	       if (errno) 
			{
			printf ("Chris there is an error\n");
		  	free(dst);
		  	free(spl);
		  	spl = NULL;
	       	}
*/
		/*	play_sample(SAMPLE *spl, int vol, int pan, int freq, int loop) */
		for (i=0;i<len;i++)
			printf ("spl->data[%d] is %d\n", i, spl->data[i]);
		play_sample(spl, 0, 0, 1000, 1);
		scanf("%c");
		}
	}
